/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <X11/Xlib.h>

#define ARC 10
#define X 20
#define Y 20
static GC gc;
static unsigned int width, height;
static unsigned int rw = 0, rh = 0;
static int px, py;

/* ɥΥĴ٤ƿ޷ΰ֤ȥƷ׻ */
static void ResetSizeAndPos(event)
    XEvent event;
{
    unsigned int old_w, old_h;
    old_w = rw;
    old_h = rh;
    width = event.xconfigure.width;
    height = event.xconfigure.height;

    /* ĹΥƷ׻ */
    rw = width - X * 2;
    rh = height - Y * 2;

    /* ߤΰ֤Ʒ׻ */
    if (old_w == 0) px = width / 2;
    else            px = (double)(px - X) * (double)rw / (double)old_w + X;
    if (old_h == 0) py = height / 2;
    else            py = (double)(py - Y) * (double)rh / (double)old_h + Y;
}

/* ɥ˿޷ */
static void Redraw(display, window)
    Display *display;
    Window window;
{
    XDrawRectangle(display, window, gc, X, Y, rw, rh);
    XFillArc(display, window, gc, px - ARC/2, py - ARC/2, ARC, ARC,
             0, 360*64);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    Display *display;
    Window window;

    /* (1) ǥץ쥤򥪡ץ */
    display = XOpenDisplay(NULL);

    /* (2) ɥƥޥå */
    window = XCreateSimpleWindow(display, RootWindow(display, 0),
                                400, 400, 200, 200, 0,
                                BlackPixel(display, 0), WhitePixel(display, 0));
    XMapWindow(display, window);

    /* (3) ٥Ƚν (٥ȡޥ) */
    XSelectInput(display, window,
                 StructureNotifyMask | ExposureMask | ButtonPressMask);

    /* (4) եåƥȤ° */
    gc = XCreateGC(display, window, NULL, NULL);
    XSetLineAttributes(display, gc, 2, LineSolid, CapButt, JoinMiter);

    while (True) {
        XEvent event;
        XNextEvent(display, &event);

        /* (5) ٥ȤȤ */
        switch (event.type) {
        case ConfigureNotify:
            ResetSizeAndPos(event);
            XClearWindow(display, window);
            Redraw(display, window);
        case Expose:
            Redraw(display, window);
            break;
        case ButtonPress:
            px = event.xbutton.x;
            py = event.xbutton.y;
            XClearWindow(display, window);
            Redraw(display, window);
            break;
        }
    }
}
